<?php

class Transition {
	
	//---------------------------------------------------------
	//  コントロール設定
	//---------------------------------------------------------
	
	public static function control() {
		
		// コントロール設定を返す
		return array(true, false, 'Header', 'Footer');
		
	}
	
	//---------------------------------------------------------
	//  順位変動を表示
	//---------------------------------------------------------
	
	public static function execute() {
		
		// DBクラスを取得
		$db = $GLOBALS['object']['db'];
		
		// テンプレートクラスを取得
		$tmpl = $GLOBALS['object']['tmpl'];
		
		// DBのサフィックスを取得
		$suffix = $GLOBALS['suffix'];
		
		////////////////////////////////////////////////////////////
		
		// アクション名を取得
		$act = $GLOBALS['args']['act'];
		
		// 項目種別を取得
		$param = $GLOBALS['args'][1];
		
		// フィルター設定を取得
		$opt = $GLOBALS['args']['opt'];
		
		// ピックアップ項目を取得
		$pickup = $GLOBALS['args']['pickup'];
		
		// 年を取得
		$y = $GLOBALS['args']['y'];
		
		// 月を取得
		$m = $GLOBALS['args']['m'];
		
		////////////////////////////////////////////////////////////
		
		// ジャンプパスを定数に設定
		define('JUMP_PATH', ROOT . '/jump/');
		
		// 最大表示文字数を定数に設定
		define('MAX_LEN', 34);
		
		// 次の月へ追加する左幅を定数に設定
		define('LEFT_PLUS', 41);
		
		////////////////////////////////////////////////////////////
		
		// DB名を設定
		$tmAtDB = 'access_' . $y . '_' . $m . $suffix;
		
		// DBが存在しない時は終了
		if (!$db->exists($tmAtDB)) {
			return;
		}
		
		////////////////////////////////////////////////////////////
		
		// テーブル名を取得
		$paramTable = $GLOBALS['config']['table']['param'];
		
		// クラスを読み込み
		include(WORK_DIR . '/actions/Param.php');
		
		// テンプレートを分割
		list($head, $body, $foot) = $tmpl->read('param_daily.htm');
		
		// ヘッダー、メイン、フッター テンプレートを取得
		list($cHead, $cLine, $cRect, $cFoot) = $tmpl->read('transition.htm');
		
		////////////////////////////////////////////////////////////
		
		// 変数を初期化
		$opt2 = '';
		$from = '';
		$where = "type = '$param'";
		$limit = '';
		$slash = '/';
		$uaType = '';
		$column1 = 'sum(count) as sum, count(distinct value) as rows';
		$column2 = '';
		$replace = '';
		
		////////////////////////////////////////////////////////////
		
		// 有無フィルターの時
		if ($opt === 'exists') {
			$replace = 'replaceOptExists';
		}
		
		// ドメインフィルターの時
		elseif ($opt === 'domain' || $opt === 'search') {
			list($replace, $column2, $from, $where) = Param::domain($db);
		}
		
		// 統合フィルターの時
		elseif ($opt === 'group') {
			list($replace, $where) = Param::group($act, $param, $where, $y, $m);
		}
		
		// ページ、リンク先、リンク元の時
		elseif ($param === 'page' || $param === 'click' || $param === 'referrer') {
			list($replace, $column2, $from, $where, $param, $opt, $slash) = Param::page($db, $param, $opt);
		}
		
		// 検索キーワードの時
		elseif ($param === 'search_word' || $param === 'search_words') {
			$replace = 'replaceSearchWord';
		}
		
		// 訪問回数の時
		elseif ($param === 'visit_count') {
			$replace = ($opt === 'repeat') ? 'replaceRepeat' : 'replaceVisit';
		}
		
		// OSの時
		elseif ($param === 'os') {
			list($replace, $where, $opt) = Param::os($opt, $pickup);
		}
		
		// UAの時
		elseif ($param === 'ua') {
			list($replace, $param, $where, $opt, $uaType, $pickup) = Param::ua($opt, $pickup);
		}
		
		// ホストドメインの時
		elseif ($param === 'host_domain') {
			list($replace, $where, $opt) = Param::hostDomain($opt);
		}
		
		// 端末機種の時
		elseif ($param === 'device') {
			$replace = Param::device();
		}
		
		////////////////////////////////////////////////////////////
		
		// 色配列を設定
		$colors[1] = '60, 60, 255';
		$colors[2] = '175, 0, 255';
		$colors[3] = '255, 50, 50';
		$colors[4] = '100, 185, 50';
		$colors[5] = '125, 125, 255';
		$colors[6] = '200, 100, 255';
		$colors[7] = '255, 150, 150';
		$colors[8] = '255, 100, 0';
		$colors[9] = '255, 200, 0';
		$colors[10] = '0, 150, 0';
		
		// 変数を初期化
		$ranks = array();
		$rects = '';
		$lines = '';
		$topPlus = 24.7;
		$leftPlus = 33;
		$beginTop = 10;
		$beginLeft = 8;
		
		////////////////////////////////////////////////////////////
		
		// 最終年月を算出
		$ey = $y + 0;
		$em = $m + 0;
		
		// 最初年月を算出
		if ($em === 12) {
			$sm = 1;
			$sy = $y;
		} else {
			$sm = $em + 1;
			$sy = $y - 1;
		}
		
		// 変数を別名で保持
		$y = $sy;
		$m = $sm;
		
		// カウンターを初期化
		$k = 0;
		
		// インテントタブを設定
		$tab1 = "\n\t\t\t\t";
		$tab2 = $tab1 . "\t";
		$tab3 = $tab2 . "\t";
		
		// ヘッダーテンプレートを追記
		$table1 = $head;
		$table2 = "\t\t\t\t" . '<table id="month">' . $tab2 . '<tr>';
		
		////////////////////////////////////////////////////////////
		
		// テーブル名取得ループ
		for ($j = 0; $j < 12; $j++) {
			
			// 月の桁数を補正
			$m = ($m < 10) ? '0' . $m : $m;
			
			// DB名を設定
			$atDB = 'access_' . $y . '_' . $m . $suffix;
			
			// 月<table>に追記
			$table2 .= $tab3 . '<td>' . (int) $m . '</td>';
			
			// DBが存在しない時は次へ
			if (!$db->exists($atDB)) {
				
				// 次のDB情報を取得
				list($y, $m, $beginLeft) = self::toNext($y, $m, $beginLeft);
				
				// 次へ
				continue;
				
			}
			
			// DBに接続
			$db->attach($atDB, 'at' . $j);
			
			// クエリーを作成
			$query3 = "select $column1 from $paramTable $from where $where;";
			
			// クエリーを実行
			$rec3 = $db->queryFetch($query3);
			
			// 総カウント数を取得
			$totalCount = $rec3['sum'];
			
			// 総件数を取得
			$allRows = $rec3['rows'];
			
			// データがない時は次へ
			if (!$allRows) {
				
				// DBと切断
				$db->detach('at' . $j);
				
				// 次のDB情報を取得
				list($y, $m, $beginLeft) = self::toNext($y, $m, $beginLeft);
				
				// 次へ
				continue;
				
			}
			
			// クエリーを作成
			$query4 = "select value, count $column2 from $paramTable $from where $where order by count desc $limit;";
			
			// クエリーを実行
			$results4 = $db->query($query4);
			
			// フィルター設定が存在する時
			if ($opt) {
				
				// フィルタリングしたデータを取得
				list($optCounts, $totalCount, $allRows) = Param::optFilter($db, $param, $opt, $results4, $totalCount, $paramTable);
				
				// パスに追記
				$opt2 = '/';
				
			}
			
			// 携帯フィルターの時はフィルターに追記
			elseif ($uaType) {
				$opt2 = $uaType . '/';
			}
			
			////////////////////////////////////////////////////////////
			
			// 最大表示件数を設定
			$limitCount = $allRows;
			
			// レコードデータ表示ループ
			for ($i = 1; ; $i++) {
				
				// フィルターが存在しない時
				if (!$opt) {
					
					// データを取得
					$vars = $db->fetch($results4);
					
					// データが無い時はループ終了
					if (!$vars) {
						break;
					}
					
				}
				
				// フィルターが存在する時
				else {
					
					// データが無い時はループ終了
					if ($i > $limitCount) {
						break;
					}
					
					// 配列のキーを取得
					$key = key($optCounts);
					
					// 項目名を取得
					$vars['value'] = $key;
					
					// カウント数を取得
					$vars['count'] = $optCounts[$key];
					
					// 配列のポインタを進める
					next($optCounts);
					
				}
				
				// 表示文字列を置換
				if ($replace) {
					$vars['value'] = Param::$replace($vars, $param);
				}
				
				// 項目名を取得
				$value = $vars['value'];
				
				// 順位を配列に設定
				$ranks[$k][$value] = $i;
				
			}
			
			////////////////////////////////////////////////////////////
			
			// 月を増加
			list($y, $m) = self::toNext($y, $m);
			
			// カウンターを1増加
			$k++;
			
			// DBと切断
			$db->detach('at' . $j);
			
		}
		
		////////////////////////////////////////////////////////////
		
		// 最終月の配列を取得
		$tmRanks = ($ranks) ? $ranks[$k - 1] : array();
		$tmCount = count($tmRanks);
		
		// カウンターを初期化
		$i = 1;
		
		// 最大表示件数+1 を算出
		$outer = ($tmCount > 10) ? 11 : $tmCount + 1;
		
		// インデントタブを設定
		$tab = "\n\t\t\t\t\t\t";
		
		////////////////////////////////////////////////////////////
		
		// 名前+順位取得ループ
		foreach ($tmRanks as $key => $val) {
			
			// 変数を初期化
			$left = $beginLeft;
			
			// 色を取得
			$vars['color'] = $colors[$i];
			
			// 折れ線を追記
			if ($i != 1) {
				$lines .= $tmpl->res($cLine, $vars);
			}
			
			// 連結点を追記
			$rects .= $tmpl->res($cRect, $vars);
			
			// 月間順位取得ループ
			for ($j = 0; $j < $k; $j++) {
				
				// 12位以下の時は11位に設定
				if (!isset($ranks[$j][$key]) || $ranks[$j][$key] > $outer) {
					$ranks[$j][$key] = $outer;
				}
				
				// 上座標を算出
				$top = $beginTop + ($topPlus * ($ranks[$j][$key] - 1));
				
				// 一番最初の時
				if ($left == $beginLeft) {
					$lines .= $tab . "ctx.moveTo($left, $top);";
				}
				
				// 二番目以降の時
				else {
					$lines .= $tab . "ctx.lineTo($left, $top);";
				}
				
				// 矩形の座標を調整
				$rectLeft = $left - 4;
				$rectTop = $top - 4;
				
				// 矩形描画メソッドを追記
				$rects .= $tab . "ctx.fillRect($rectLeft, $rectTop, 7, 7);";
				
				// 左座標を移動
				$left += $leftPlus;
				
			}
			
			// 表示用に項目名を整形
			if ($param === 'host_domain') {
				$key = preg_replace('/\(.+/', '', $key);
			} elseif ($opt2 === 'mobile/') {
				$key = preg_replace('/^([\S]+) ([\S]+) .+/', "$1 $2", $key);
			}
			
			// テンプレート変数を設定
			$vars['tr'] = 'b' . $i;
			$vars['rank'] = $i;
			$vars['value'] = $key;
			$vars['count'] = '';
			
			// メインテンプレートを出力
			$table1 .= $tmpl->res($body, $vars);
			
			// 10位に達したら終了
			if ($i == 10) {
				break;
			}
			
			// 順位を1増加
			$i++;
			
		}
		
		////////////////////////////////////////////////////////////
		
		// キャンバスを出力
		echo $cHead . $lines . $rects . $cFoot;
		
		// フッターテンプレートを追記
		$table1 .= $foot;
		$table2 .= $tab2 . '</tr>' . $tab1 . '</table>' . "\n";
		
		// 項目テーブルを出力
		echo $table2 . $table1;
		
	}
	
	//---------------------------------------------------------
	//  次への処理
	//---------------------------------------------------------
	
	private static function toNext($y, $m, $beginLeft = '') {
		
		// 月を増加
		$m++;
		
		// 12月までいったら年を繰り越し
		if ($m == '13') {
			$y++;
			$m = 1;
		}
		
		// 初期位置をずらす
		if ($beginLeft) {
			$beginLeft += LEFT_PLUS;
		}
		
		// 年月、初期位置を返す
		return array($y, $m, $beginLeft);
		
	}
	
}

