<?php

class Login {
	
	//---------------------------------------------------------
	//  ログイン処理
	//---------------------------------------------------------
	
	public static function execute() {
		
		// 変数を初期化
		$username = '';
		$password = '';
		
		// フォームデータが存在する時
		if (isset($_POST['login'])) {
			
			// ユーザーIDを取得
			$username = (isset($_POST['username'])) ? md5($_POST['username']) : '';
			
			// パスワードを取得
			$password = (isset($_POST['password'])) ? md5($_POST['password']) : '';
			
		}
		
		// Cookieが存在する時
		elseif (isset($_COOKIE['lunalysLogin'])) {
			
			// Cookieをパース
			parse_str($_COOKIE['lunalysLogin'], $results);
			
			// ユーザーIDを取得
			$username = (isset($results['username'])) ? $results['username'] : '';
			
			// パスワードを取得
			$password = (isset($results['password'])) ? $results['password'] : '';
			
		}
		
		// 管理者の時は何もしない
		if ($username === md5($GLOBALS['config']['login']['username']) && $password === md5($GLOBALS['config']['login']['password'])) {
			
		}
		
		// 一般ユーザーの時は管理者フラグをリセット
		elseif (isset($GLOBALS['config']['account']) && self::isValid($username, $password)) {
			$GLOBALS['isAdmin'] = false;
		}
		
		// IDもしくはPWが一致しない時はログインフォームを表示
		else {
			exit(self::showForm());
		}
		
		// Cookieの有効期限を設定
		$time = $_SERVER['REQUEST_TIME'] + (60 * 60 * 24 * 365);
		
		// 現在のホストドメインを取得
		$host = $_SERVER['SERVER_NAME'];
		
		// Cookieを発行
		setcookie('lunalysLogin', "username=$username&password=$password", $time, '/', $host);
		
	}
	
	//---------------------------------------------------------
	//  有効なID＆PWかバリデート
	//---------------------------------------------------------
	
	private static function isValid($username, $password) {
		
		// 5回ループ
		for ($j = 1; $j < 6; $j++) {
			
			// 配列のキーを設定
			$key1 = 'username' . $j;
			$key2 = 'password' . $j;
			
			// 設定配列に存在しない時は次へ
			if (!isset($GLOBALS['config']['account'][$key1])) {
				continue;
			}
			
			// ユーザー名とパスワードが一致した場合はtrueを返す
			elseif ($username === md5($GLOBALS['config']['account'][$key1]) && $password === md5($GLOBALS['config']['account'][$key2])) {
				return true;
			}
			
		}
		
		// falseを返す
		return false;
		
	}
	
	//---------------------------------------------------------
	//  ログインフォーム表示
	//---------------------------------------------------------
	
	public static function showForm() {
		
		// テンプレートクラスを取得
		$tmpl = $GLOBALS['object']['tmpl'];
		
		// テンプレートを読み込み
		$html = $tmpl->read('login.htm', false);
		
		// URLルートを設定
		$vars['root'] = ROOT;
		
		// URLルートディレクトリを設定
		$vars['rootDir'] = ROOT_DIR;
		
		// ユーザー名に空欄を設定
		$vars['username'] = '';
		
		// パスワードに空欄を設定
		$vars['password'] = '';
		
		// テンプレートを出力
		$tmpl->show($html, $vars);
		
	}
	
}

